Index: pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 850)
+++ pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 851)
@@ -3715,52 +3386,70 @@
 static PyMemberDef acc_config_members[] =
 {
-	{
-    	"priority", T_INT, offsetof(acc_config_Object, priority), 0,
-    	"Account priority, which is used to control the order of matching "
-		"incoming/outgoing requests. The higher the number means the higher "
-		"the priority is, and the account will be matched first. "
-    },
-	{
-    	"id", T_OBJECT_EX,
-    	offsetof(acc_config_Object, id), 0,
-    	"The full SIP URL for the account. "
-		"The value can take name address or URL format, "
-		"and will look something like 'sip:account@serviceprovider'. "
-		"This field is mandatory."
-    },
-	{
-    	"reg_uri", T_OBJECT_EX,
-    	offsetof(acc_config_Object, reg_uri), 0,
-    	"This is the URL to be put in the request URI for the registration, "
-		"and will look something like 'sip:serviceprovider'. "
-		"This field should be specified if registration is desired. "
-		"If the value is empty, no account registration will be performed. "
-    },
-	{
-    	"publish_enabled", T_INT, 
-			offsetof(acc_config_Object, publish_enabled), 0,
-    	"Publish presence? "
-    },
-	{
-    	"force_contact", T_OBJECT_EX,
-    	offsetof(acc_config_Object, force_contact), 0,
-    	"Optional URI to be put as Contact for this account. "
-		"It is recommended that this field is left empty, "
-		"so that the value will be calculated automatically "
-		"based on the transport address. "
-    },
-	{
-    	"proxy_cnt", T_INT, offsetof(acc_config_Object, proxy_cnt), 0,
-    	"Number of proxies in the proxy array below. "
-    },
-	{
-    	"reg_timeout", T_INT, offsetof(acc_config_Object, reg_timeout), 0,
-    	"Optional interval for registration, in seconds. "
-		"If the value is zero, default interval will be used "
-		"(PJSUA_REG_INTERVAL, 55 seconds). "
-    },
-	{
-    	"cred_count", T_INT, offsetof(acc_config_Object, cred_count), 0,
-    	"Number of credentials in the credential array. "
+    {
+        "priority", T_INT, offsetof(acc_config_Object, priority), 0,
+        "Account priority, which is used to control the order of matching "
+        "incoming/outgoing requests. The higher the number means the higher "
+        "the priority is, and the account will be matched first. "
+    },
+    {
+        "id", T_OBJECT_EX,
+        offsetof(acc_config_Object, id), 0,
+        "The full SIP URL for the account. "
+        "The value can take name address or URL format, "
+        "and will look something like 'sip:account@serviceprovider'. "
+        "This field is mandatory."
+    },
+    {
+        "reg_uri", T_OBJECT_EX,
+        offsetof(acc_config_Object, reg_uri), 0,
+        "This is the URL to be put in the request URI for the registration, "
+        "and will look something like 'sip:serviceprovider'. "
+        "This field should be specified if registration is desired. "
+        "If the value is empty, no account registration will be performed. "
+    },
+    {
+        "publish_enabled", T_INT, 
+        offsetof(acc_config_Object, publish_enabled), 0,
+        "Publish presence? "
+    },
+    {
+        "force_contact", T_OBJECT_EX,
+        offsetof(acc_config_Object, force_contact), 0,
+        "Optional URI to be put as Contact for this account. "
+        "It is recommended that this field is left empty, "
+        "so that the value will be calculated automatically "
+        "based on the transport address. "
+    },
+    {
+        "proxy_cnt", T_INT, offsetof(acc_config_Object, proxy_cnt), 0,
+        "Number of proxies in the proxy array below. "
+    },
+    {
+        "proxy", T_OBJECT_EX,
+        offsetof(acc_config_Object, proxy), 0,
+        "Optional URI of the proxies to be visited for all outgoing requests "
+	"that are using this account (REGISTER, INVITE, etc). Application need "
+	"to specify these proxies if the service provider requires "
+	"that requests destined towards its network should go through certain "
+	"proxies first (for example, border controllers)."
+    },
+    {
+        "reg_timeout", T_INT, offsetof(acc_config_Object, reg_timeout), 0,
+        "Optional interval for registration, in seconds. "
+        "If the value is zero, default interval will be used "
+        "(PJSUA_REG_INTERVAL, 55 seconds). "
+    },
+    {
+        "cred_count", T_INT, offsetof(acc_config_Object, cred_count), 0,
+        "Number of credentials in the credential array. "
+    },
+    {
+        "cred_info", T_OBJECT_EX,
+        offsetof(acc_config_Object, cred_info), 0,
+        "Array of credentials. If registration is desired, normally there "
+	"should be at least one credential specified, to successfully "
+	"authenticate against the service provider. More credentials can "
+	"be specified, for example when the requests are expected to be "
+	"challenged by the proxies in the route set."
     },
     {NULL}  /* Sentinel */
@@ -3803,5 +3492,5 @@
     0,                              /* tp_iter */
     0,                              /* tp_iternext */
-    acc_config_methods,                              /* tp_methods */
+    0/*acc_config_methods*/,                              /* tp_methods */
     acc_config_members,         /* tp_members */
     0,                              /* tp_getset */
@@ -3825,13 +3514,13 @@
     PyObject_HEAD
     /* Type-specific fields go here. */
-	int id;	
-	int is_default;
-	PyObject * acc_uri;
-	int has_registration;
-	int expires;
-	int status;
-	PyObject * status_text;
-	int online_status;	
-	char buf_[PJ_ERR_MSG_SIZE];
+    int id;	
+    int is_default;
+    PyObject * acc_uri;
+    int has_registration;
+    int expires;
+    int status;
+    PyObject * status_text;
+    int online_status;	
+    char buf_[PJ_ERR_MSG_SIZE];
 } acc_info_Object;
 
@@ -3844,5 +3533,5 @@
 {
     Py_XDECREF(self->acc_uri); 
-	Py_XDECREF(self->status_text);	
+    Py_XDECREF(self->status_text);	
     self->ob_type->tp_free((PyObject*)self);
 }
@@ -3861,5 +3550,5 @@
     if (self != NULL)
     {
-		self->acc_uri = PyString_FromString("");
+        self->acc_uri = PyString_FromString("");
         if (self->acc_uri == NULL)
     	{
@@ -3882,19 +3571,19 @@
 (acc_info_Object *self, PyObject * args)
 {
-	int idx;
-	char elmt;
-	if (!PyArg_ParseTuple(args,"i",&idx)) 
-	{
-		return NULL;
-	}
-	if ((idx >= 0) && (idx < PJ_ERR_MSG_SIZE)) 
-	{
-		elmt = self->buf_[idx];
-	} 
-	else
-	{
-		return NULL;
-	}
-	return PyString_FromStringAndSize(&elmt, 1);
+    int idx;
+    char elmt;
+    if (!PyArg_ParseTuple(args,"i",&idx)) 
+    {
+        return NULL;
+    }
+    if ((idx >= 0) && (idx < PJ_ERR_MSG_SIZE)) 
+    {
+        elmt = self->buf_[idx];
+    } 
+    else
+    {
+        return NULL;
+    }
+    return PyString_FromStringAndSize(&elmt, 1);
 }
 
@@ -3902,39 +3591,39 @@
 (acc_info_Object *self, PyObject * args)
 {
-	int idx;
-	PyObject * str;	
-	char * s;
-	if (!PyArg_ParseTuple(args,"iO",&idx, &str)) 
-	{
-		return NULL;
-	}
-	if ((idx >= 0) && (idx < PJ_ERR_MSG_SIZE)) 
-	{
-		s = PyString_AsString(str);
-		if (s[0]) 
-		{
-			self->buf_[idx] = s[0];
-		} 
-		else 
-		{
-			return NULL;
-		}
-	} 
-	else
-	{
-		return NULL;
-	}
-	Py_INCREF(Py_None);
-	return Py_None;
+    int idx;
+    PyObject * str;	
+    char * s;
+    if (!PyArg_ParseTuple(args,"iO",&idx, &str)) 
+    {
+        return NULL;
+    }
+    if ((idx >= 0) && (idx < PJ_ERR_MSG_SIZE)) 
+    {
+        s = PyString_AsString(str);
+        if (s[0]) 
+        {
+        self->buf_[idx] = s[0];
+        }	 
+	else 
+        {
+            return NULL;
+        }
+    } 
+    else
+    {
+        return NULL;
+    }
+    Py_INCREF(Py_None);
+    return Py_None;
 }
 
 static PyMethodDef acc_info_methods[] = {
     {
-		"get_buf", (PyCFunction)acc_info_get_buf, METH_VARARGS,
-		"Return buf char at specified index"
-    },
-	{
-		"set_buf", (PyCFunction)acc_info_set_buf, METH_VARARGS,
-		"Set buf at specified index"
+        "get_buf", (PyCFunction)acc_info_get_buf, METH_VARARGS,
+        "Return buf char at specified index"
+    },
+    {
+        "set_buf", (PyCFunction)acc_info_set_buf, METH_VARARGS,
+        "Set buf at specified index"
     },
 	
@@ -3949,41 +3638,41 @@
 static PyMemberDef acc_info_members[] =
 {
-	{
-    	"id", T_INT, offsetof(acc_info_Object, id), 0,
-    	"The account ID."
-    },
-	{
-    	"is_default", T_INT, offsetof(acc_info_Object, is_default), 0,
-    	"Flag to indicate whether this is the default account. "
-    },
-	{
-    	"acc_uri", T_OBJECT_EX,
-    	offsetof(acc_info_Object, acc_uri), 0,
-    	"Account URI"
-    },
-	{
-    	"has_registration", T_INT, offsetof(acc_info_Object, has_registration),
-		0,
-    	"Flag to tell whether this account has registration setting "
-		"(reg_uri is not empty)."
-    },
-	{
-    	"expires", T_INT, offsetof(acc_info_Object, expires), 0,
-    	"An up to date expiration interval for account registration session."
-    },
-	{
-    	"status", T_INT, offsetof(acc_info_Object, status), 0,
-    	"Last registration status code. If status code is zero, "
-		"the account is currently not registered. Any other value indicates "
-		"the SIP status code of the registration. "
-    },
-	{
-    	"status_text", T_OBJECT_EX,
-    	offsetof(acc_info_Object, status_text), 0,
-    	"String describing the registration status."
-    },
-	{
-    	"online_status", T_INT, offsetof(acc_info_Object, online_status), 0,
-    	"Presence online status for this account. "
+    {
+        "id", T_INT, offsetof(acc_info_Object, id), 0,
+        "The account ID."
+    },
+    {
+        "is_default", T_INT, offsetof(acc_info_Object, is_default), 0,
+        "Flag to indicate whether this is the default account. "
+    },
+    {
+        "acc_uri", T_OBJECT_EX,
+        offsetof(acc_info_Object, acc_uri), 0,
+        "Account URI"
+    },
+    {
+        "has_registration", T_INT, offsetof(acc_info_Object, has_registration),
+        0,
+        "Flag to tell whether this account has registration setting "
+        "(reg_uri is not empty)."
+    },
+    {
+        "expires", T_INT, offsetof(acc_info_Object, expires), 0,
+        "An up to date expiration interval for account registration session."
+    },
+    {
+        "status", T_INT, offsetof(acc_info_Object, status), 0,
+        "Last registration status code. If status code is zero, "
+        "the account is currently not registered. Any other value indicates "
+        "the SIP status code of the registration. "
+    },
+    {
+        "status_text", T_OBJECT_EX,
+        offsetof(acc_info_Object, status_text), 0,
+        "String describing the registration status."
+    },
+    {
+        "online_status", T_INT, offsetof(acc_info_Object, online_status), 0,
+        "Presence online status for this account. "
     },
     {NULL}  /* Sentinel */
@@ -4040,7 +3729,633 @@
 };
 
-/*
- * acc_id_Object
- * C/Python wrapper for acc_id object
+
+
+/*
+ * py_pjsua_acc_config_default
+ * !modified @ 051206
+ */
+static PyObject *py_pjsua_acc_config_default
+(PyObject *pSelf, PyObject *pArgs)
+{
+    acc_config_Object *obj;
+    pjsua_acc_config cfg;
+    int i;
+
+    if (!PyArg_ParseTuple(pArgs, ""))
+    {
+        return NULL;
+    }
+    pjsua_acc_config_default(&cfg);
+    obj = (acc_config_Object *)acc_config_new(&acc_config_Type, NULL, NULL);
+    obj->cred_count = cfg.cred_count;
+    for (i = 0; i < 8; i++) 
+    {
+        /*obj->cred_info[i] = cfg.cred_info[i];*/
+	int ret;
+	pjsip_cred_info_Object * ci = 
+	    (pjsip_cred_info_Object *)pjsip_cred_info_new
+	    (&pjsip_cred_info_Type,NULL,NULL);
+	ci->data = PyString_FromStringAndSize(cfg.cred_info[i].data.ptr, 
+	    cfg.cred_info[i].data.slen);
+	ci->realm = PyString_FromStringAndSize(cfg.cred_info[i].realm.ptr, 
+	    cfg.cred_info[i].realm.slen);
+	ci->scheme = PyString_FromStringAndSize(cfg.cred_info[i].scheme.ptr, 
+	    cfg.cred_info[i].scheme.slen);
+	ci->username = PyString_FromStringAndSize(cfg.cred_info[i].username.ptr, 
+	    cfg.cred_info[i].username.slen);
+	ci->data_type = cfg.cred_info[i].data_type;
+	ret = PyList_SetItem((PyObject *)obj->cred_info,i,(PyObject *)ci);
+	if (ret == -1) {
+	    return NULL;
+	}
+    }
+    
+    Py_XDECREF(obj->force_contact);
+    obj->force_contact = 
+        PyString_FromStringAndSize(cfg.force_contact.ptr, 
+        cfg.force_contact.slen);
+    obj->priority = cfg.priority;
+    Py_XDECREF(obj->id);
+    obj->id = 
+        PyString_FromStringAndSize(cfg.id.ptr, cfg.id.slen);
+    Py_XDECREF(obj->reg_uri);
+    obj->reg_uri = 
+        PyString_FromStringAndSize(cfg.reg_uri.ptr, cfg.reg_uri.slen);
+    obj->proxy_cnt = cfg.proxy_cnt;
+    for (i = 0; i < 8; i++) 
+    {
+	PyObject * str;
+	int ret;
+        /*obj->proxy[i] = cfg.proxy[i];*/
+	str = PyString_FromStringAndSize(cfg.proxy[i].ptr, cfg.proxy[i].slen);
+	ret = PyList_SetItem((PyObject *)obj->proxy,i,str);
+	if (ret == -1) {
+	    return NULL;
+	}
+    }
+    obj->publish_enabled = cfg.publish_enabled;
+    obj->reg_timeout = cfg.reg_timeout;
+	
+    return (PyObject *)obj;
+}
+
+/*
+ * py_pjsua_acc_get_count
+ */
+static PyObject *py_pjsua_acc_get_count
+(PyObject *pSelf, PyObject *pArgs)
+{
+    int count;
+    if (!PyArg_ParseTuple(pArgs, ""))
+    {
+        return NULL;
+    }
+    count = pjsua_acc_get_count();
+    return Py_BuildValue("i",count);
+}
+
+/*
+ * py_pjsua_acc_is_valid
+ */
+static PyObject *py_pjsua_acc_is_valid
+(PyObject *pSelf, PyObject *pArgs)
+{    
+    int id;
+    int is_valid;
+
+    if (!PyArg_ParseTuple(pArgs, "i", &id))
+    {
+        return NULL;
+    }
+    is_valid = pjsua_acc_is_valid(id);
+	
+    return Py_BuildValue("i", is_valid);
+}
+
+/*
+ * py_pjsua_acc_set_default
+ */
+static PyObject *py_pjsua_acc_set_default
+(PyObject *pSelf, PyObject *pArgs)
+{    
+    int id;
+    int status;
+
+    if (!PyArg_ParseTuple(pArgs, "i", &id))
+    {
+        return NULL;
+    }
+    status = pjsua_acc_set_default(id);
+	
+    return Py_BuildValue("i", status);
+}
+
+/*
+ * py_pjsua_acc_get_default
+ */
+static PyObject *py_pjsua_acc_get_default
+(PyObject *pSelf, PyObject *pArgs)
+{    
+    int id;
+	
+    if (!PyArg_ParseTuple(pArgs, ""))
+    {
+        return NULL;
+    }
+    id = pjsua_acc_get_default();
+	
+    return Py_BuildValue("i", id);
+}
+
+/*
+ * py_pjsua_acc_add
+ * !modified @ 051206
+ */
+static PyObject *py_pjsua_acc_add
+(PyObject *pSelf, PyObject *pArgs)
+{    
+    int is_default;
+    acc_config_Object * ac;
+    pjsua_acc_config cfg;
+    
+    int p_acc_id;
+    int status;
+    int i;
+
+    if (!PyArg_ParseTuple(pArgs, "Oi", &ac, &is_default))
+    {
+        return NULL;
+    }
+    cfg.cred_count = ac->cred_count;
+    for (i = 0; i < 8; i++) 
+    {
+        /*cfg.cred_info[i] = ac->cred_info[i];*/
+	pjsip_cred_info_Object * ci = (pjsip_cred_info_Object *)PyList_GetItem((PyObject *)ac->cred_info,i);
+	cfg.cred_info[i].data.ptr = PyString_AsString(ci->data);
+	cfg.cred_info[i].data.slen = strlen(PyString_AsString(ci->data));
+	cfg.cred_info[i].realm.ptr = PyString_AsString(ci->realm);
+	cfg.cred_info[i].realm.slen = strlen(PyString_AsString(ci->realm));
+	cfg.cred_info[i].scheme.ptr = PyString_AsString(ci->scheme);
+	cfg.cred_info[i].scheme.slen = strlen(PyString_AsString(ci->scheme));
+	cfg.cred_info[i].username.ptr = PyString_AsString(ci->username);
+	cfg.cred_info[i].username.slen = strlen(PyString_AsString(ci->username));
+	cfg.cred_info[i].data_type = ci->data_type;
+    }
+    cfg.force_contact.ptr = PyString_AsString(ac->force_contact);
+    cfg.force_contact.slen = strlen(PyString_AsString(ac->force_contact));
+    cfg.id.ptr = PyString_AsString(ac->id);
+    cfg.id.slen = strlen(PyString_AsString(ac->id));
+    cfg.priority = ac->priority;
+    for (i = 0; i < 8; i++) {
+        /*cfg.proxy[i] = ac->proxy[i];*/
+	cfg.proxy[i].ptr = PyString_AsString(PyList_GetItem((PyObject *)ac->proxy,i));
+    }
+    cfg.proxy_cnt = ac->proxy_cnt;
+    cfg.publish_enabled = ac->publish_enabled;
+    cfg.reg_timeout = ac->reg_timeout;
+    cfg.reg_uri.ptr = PyString_AsString(ac->reg_uri);
+    cfg.reg_uri.slen = strlen(PyString_AsString(ac->reg_uri));
+    
+    status = pjsua_acc_add(&cfg, is_default, &p_acc_id);
+    
+    return Py_BuildValue("ii", status, p_acc_id);
+}
+
+/*
+ * py_pjsua_acc_add_local
+ * !modified @ 051206
+ */
+static PyObject *py_pjsua_acc_add_local
+(PyObject *pSelf, PyObject *pArgs)
+{    
+    int is_default;
+    int tid;
+    
+    int p_acc_id;
+    int status;
+	
+
+    if (!PyArg_ParseTuple(pArgs, "iiO", &tid, &is_default))
+    {
+        return NULL;
+    }
+	
+    
+    status = pjsua_acc_add_local(tid, is_default, &p_acc_id);
+    
+    return Py_BuildValue("ii", status, p_acc_id);
+}
+
+/*
+ * py_pjsua_acc_del
+ */
+static PyObject *py_pjsua_acc_del
+(PyObject *pSelf, PyObject *pArgs)
+{    
+    int acc_id;
+    int status;
+
+    if (!PyArg_ParseTuple(pArgs, "i", &acc_id))
+    {
+        return NULL;
+    }
+	
+	
+    status = pjsua_acc_del(acc_id);	
+    return Py_BuildValue("i", status);
+}
+
+/*
+ * py_pjsua_acc_modify
+ */
+static PyObject *py_pjsua_acc_modify
+(PyObject *pSelf, PyObject *pArgs)
+{    	
+    acc_config_Object * ac;
+    pjsua_acc_config cfg;	
+    int acc_id;
+    int status;
+    int i;
+
+    if (!PyArg_ParseTuple(pArgs, "iO", &acc_id, &ac))
+    {
+        return NULL;
+    }
+    cfg.cred_count = ac->cred_count;
+    for (i = 0; i < 8; i++) 
+    {
+        /*cfg.cred_info[i] = ac->cred_info[i];*/
+	pjsip_cred_info_Object * ci = (pjsip_cred_info_Object *)PyList_GetItem((PyObject *)ac->cred_info,i);
+	cfg.cred_info[i].data.ptr = PyString_AsString(ci->data);
+	cfg.cred_info[i].data.slen = strlen(PyString_AsString(ci->data));
+	cfg.cred_info[i].realm.ptr = PyString_AsString(ci->realm);
+	cfg.cred_info[i].realm.slen = strlen(PyString_AsString(ci->realm));
+	cfg.cred_info[i].scheme.ptr = PyString_AsString(ci->scheme);
+	cfg.cred_info[i].scheme.slen = strlen(PyString_AsString(ci->scheme));
+	cfg.cred_info[i].username.ptr = PyString_AsString(ci->username);
+	cfg.cred_info[i].username.slen = strlen(PyString_AsString(ci->username));
+    }
+    cfg.force_contact.ptr = PyString_AsString(ac->force_contact);
+    cfg.force_contact.slen = strlen(PyString_AsString(ac->force_contact));
+    cfg.id.ptr = PyString_AsString(ac->id);
+    cfg.id.slen = strlen(PyString_AsString(ac->id));
+    cfg.priority = ac->priority;
+    for (i = 0; i < 8; i++) {
+        /*cfg.proxy[i] = ac->proxy[i];*/
+	cfg.proxy[i].ptr = PyString_AsString(PyList_GetItem((PyObject *)ac->proxy,i));
+    }
+    cfg.proxy_cnt = ac->proxy_cnt;
+    cfg.publish_enabled = ac->publish_enabled;
+    cfg.reg_timeout = ac->reg_timeout;
+    cfg.reg_uri.ptr = PyString_AsString(ac->reg_uri);
+    cfg.reg_uri.slen = strlen(PyString_AsString(ac->reg_uri));	
+    status = pjsua_acc_modify(acc_id, &cfg);	
+    return Py_BuildValue("i", status);
+}
+
+/*
+ * py_pjsua_acc_set_online_status
+ */
+static PyObject *py_pjsua_acc_set_online_status
+(PyObject *pSelf, PyObject *pArgs)
+{    
+    int is_online;	
+    int acc_id;
+    int status;	
+
+    if (!PyArg_ParseTuple(pArgs, "ii", &acc_id, &is_online))
+    {
+        return NULL;
+    }
+	
+    status = pjsua_acc_set_online_status(acc_id, is_online);
+	
+    return Py_BuildValue("i", status);
+}
+
+/*
+ * py_pjsua_acc_set_registration
+ */
+static PyObject *py_pjsua_acc_set_registration
+(PyObject *pSelf, PyObject *pArgs)
+{    
+    int renew;	
+    int acc_id;
+    int status;	
+
+    if (!PyArg_ParseTuple(pArgs, "ii", &acc_id, &renew))
+    {
+        return NULL;
+    }
+	
+    status = pjsua_acc_set_registration(acc_id, renew);
+	
+    return Py_BuildValue("i", status);
+}
+
+/*
+ * py_pjsua_acc_get_info
+ * !modified @ 051206
+ */
+static PyObject *py_pjsua_acc_get_info
+(PyObject *pSelf, PyObject *pArgs)
+{    	
+    int acc_id;
+    acc_info_Object * obj;
+    pjsua_acc_info info;
+    int status;	
+    int i;
+
+    if (!PyArg_ParseTuple(pArgs, "i", &acc_id))
+    {
+        return NULL;
+    }
+	
+    
+    status = pjsua_acc_get_info(acc_id, &info);
+    if (status == PJ_SUCCESS) {
+	obj = (acc_info_Object *)acc_info_new(&acc_info_Type,NULL, NULL);
+        obj->acc_uri =
+            PyString_FromStringAndSize(info.acc_uri.ptr, 
+            info.acc_uri.slen);
+        for (i = 0; i < PJ_ERR_MSG_SIZE; i++) {
+            obj->buf_[i] = info.buf_[i];
+	}
+        obj->expires = info.expires;
+        obj->has_registration = info.has_registration;
+        obj->id = info.id;
+        obj->is_default = info.is_default;
+        obj->online_status = info.online_status;
+        obj->status = info.status;
+        obj->status_text =
+	    PyString_FromStringAndSize(info.status_text.ptr, 
+	    info.status_text.slen);
+        return Py_BuildValue("O", obj);
+    } else {
+	Py_INCREF(Py_None);
+	return Py_None;
+    }
+}
+
+/*
+ * py_pjsua_enum_accs
+ * !modified @ 051206
+ */
+static PyObject *py_pjsua_enum_accs(PyObject *pSelf, PyObject *pArgs)
+{
+    pj_status_t status;
+    PyObject *list;
+    
+    pjsua_acc_id *id;
+    int c, i;
+    if (!PyArg_ParseTuple(pArgs, "i", &c))
+    {
+        return NULL;
+    }	
+    
+    id = (pjsua_acc_id *)malloc(c * sizeof(pjsua_acc_id));
+    status = pjsua_enum_accs(id, &c);
+    
+    list = PyList_New(c);
+    for (i = 0; i < c; i++) {
+        int ret = PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
+        if (ret == -1) {
+            return NULL;
+	}
+    }
+    
+    free(id);
+    return Py_BuildValue("O",list);
+}
+
+/*
+ * py_pjsua_acc_enum_info
+ * !modified @ 051206
+ */
+static PyObject *py_pjsua_acc_enum_info(PyObject *pSelf, PyObject *pArgs)
+{
+    pj_status_t status;
+    PyObject *list;
+    
+    pjsua_acc_info *info;
+    int c, i;
+    if (!PyArg_ParseTuple(pArgs, "i", &c))
+    {
+        return NULL;
+    }	
+    
+    info = (pjsua_acc_info *)malloc(c * sizeof(pjsua_acc_info));
+    status = pjsua_acc_enum_info(info, &c);
+    
+    list = PyList_New(c);
+    for (i = 0; i < c; i++) {
+        int ret;
+	int j;
+	acc_info_Object *obj;
+	obj = (acc_info_Object *)acc_info_new(&acc_info_Type,NULL,NULL);
+	obj->acc_uri = PyString_FromStringAndSize
+	    (info[i].acc_uri.ptr, info[i].acc_uri.slen);
+	for(j = 0; j < PJ_ERR_MSG_SIZE; j++) {
+	    obj->buf_[j] = info[i].buf_[j];
+	}
+	obj->expires = info[i].expires;
+	obj->has_registration = info[i].has_registration;
+	obj->id = info[i].id;
+	obj->is_default = info[i].is_default;
+	obj->online_status = info[i].online_status;
+	obj->status = info[i].status;
+	obj->status_text = PyString_FromStringAndSize(info[i].status_text.ptr,
+	    info[i].status_text.slen);
+	ret = PyList_SetItem(list, i, (PyObject *)obj);
+        if (ret == -1) {
+	    return NULL;
+        }
+    }
+    
+    free(info);
+    return Py_BuildValue("O",list);
+}
+
+/*
+ * py_pjsua_acc_find_for_outgoing
+ */
+static PyObject *py_pjsua_acc_find_for_outgoing
+(PyObject *pSelf, PyObject *pArgs)
+{    
+	
+    int acc_id;	
+    PyObject * url;
+    pj_str_t str;
+
+    if (!PyArg_ParseTuple(pArgs, "O", &url))
+    {
+        return NULL;
+    }
+    str.ptr = PyString_AsString(url);
+    str.slen = strlen(PyString_AsString(url));
+	
+    acc_id = pjsua_acc_find_for_outgoing(&str);
+	
+    return Py_BuildValue("i", acc_id);
+}
+
+/*
+ * py_pjsua_acc_find_for_incoming
+ */
+static PyObject *py_pjsua_acc_find_for_incoming
+(PyObject *pSelf, PyObject *pArgs)
+{    	
+    int acc_id;	
+    pjsip_rx_data_Object * obj;
+    pjsip_rx_data * rdata;
+
+    if (!PyArg_ParseTuple(pArgs, "O", &obj))
+    {
+        return NULL;
+    }
+	
+    rdata = obj->rdata;
+    acc_id = pjsua_acc_find_for_incoming(rdata);
+	
+    return Py_BuildValue("i", acc_id);
+}
+
+/*
+ * py_pjsua_acc_create_uac_contact
+ * !modified @ 061206
+ */
+static PyObject *py_pjsua_acc_create_uac_contact
+(PyObject *pSelf, PyObject *pArgs)
+{    	
+    int status;
+    int acc_id;	
+    pj_pool_Object * p;
+    pj_pool_t * pool;
+    PyObject * strc;
+    pj_str_t contact;
+    PyObject * stru;
+    pj_str_t uri;
+
+    if (!PyArg_ParseTuple(pArgs, "OiO", &p, &acc_id, &stru))
+    {
+        return NULL;
+    }
+	
+    pool = p->pool;    
+    uri.ptr = PyString_AsString(stru);
+    uri.slen = strlen(PyString_AsString(stru));
+    status = pjsua_acc_create_uac_contact(pool, &contact, acc_id, &uri);
+    strc = PyString_FromStringAndSize(contact.ptr, contact.slen);
+	
+    return Py_BuildValue("O", strc);
+}
+
+/*
+ * py_pjsua_acc_create_uas_contact
+ * !modified @ 061206
+ */
+static PyObject *py_pjsua_acc_create_uas_contact
+(PyObject *pSelf, PyObject *pArgs)
+{    	
+    int status;
+    int acc_id;	
+    pj_pool_Object * p;
+    pj_pool_t * pool;
+    PyObject * strc;
+    pj_str_t contact;
+    pjsip_rx_data_Object * objr;
+    pjsip_rx_data * rdata;
+
+    if (!PyArg_ParseTuple(pArgs, "OiO", &p, &acc_id, &objr))
+    {
+        return NULL;
+    }
+	
+    pool = p->pool;
+    
+    rdata = objr->rdata;
+    status = pjsua_acc_create_uas_contact(pool, &contact, acc_id, rdata);
+    strc = PyString_FromStringAndSize(contact.ptr, contact.slen);
+	
+    return Py_BuildValue("O", strc);
+}
+
+static char pjsua_acc_config_default_doc[] =
+    "py_pjsua.Acc_Config py_pjsua.acc_config_default () "
+    "Call this function to initialize account config with default values.";
+static char pjsua_acc_get_count_doc[] =
+    "int py_pjsua.acc_get_count () "
+    "Get number of current accounts.";
+static char pjsua_acc_is_valid_doc[] =
+    "int py_pjsua.acc_is_valid (int acc_id)  "
+    "Check if the specified account ID is valid.";
+static char pjsua_acc_set_default_doc[] =
+    "int py_pjsua.acc_set_default (int acc_id) "
+    "Set default account to be used when incoming "
+    "and outgoing requests doesn't match any accounts.";
+static char pjsua_acc_get_default_doc[] =
+    "int py_pjsua.acc_get_default () "
+    "Get default account.";
+static char pjsua_acc_add_doc[] =
+    "int, int py_pjsua.acc_add (py_pjsua.Acc_Config cfg, "
+    "int is_default) "
+    "Add a new account to pjsua. PJSUA must have been initialized "
+    "(with pjsua_init()) before calling this function.";
+static char pjsua_acc_add_local_doc[] =
+    "int,int py_pjsua.acc_add_local (int tid, "
+    "int is_default) "
+    "Add a local account. A local account is used to identify "
+    "local endpoint instead of a specific user, and for this reason, "
+    "a transport ID is needed to obtain the local address information.";
+static char pjsua_acc_del_doc[] =
+    "int py_pjsua.acc_del (int acc_id) "
+    "Delete account.";
+static char pjsua_acc_modify_doc[] =
+    "int py_pjsua.acc_modify (int acc_id, py_pjsua.Acc_Config cfg) "
+    "Modify account information.";
+static char pjsua_acc_set_online_status_doc[] =
+    "int py_pjsua.acc_set_online_status (int acc_id, int is_online) "
+    "Modify account's presence status to be advertised "
+    "to remote/presence subscribers.";
+static char pjsua_acc_set_registration_doc[] =
+    "int py_pjsua.acc_set_registration (int acc_id, int renew) "
+    "Update registration or perform unregistration.";
+static char pjsua_acc_get_info_doc[] =
+    "py_pjsua.Acc_Info py_pjsua.acc_get_info (int acc_id) "
+    "Get account information.";
+static char pjsua_enum_accs_doc[] =
+    "int[] py_pjsua.enum_accs (int count) "
+    "Enum accounts all account ids.";
+static char pjsua_acc_enum_info_doc[] =
+    "py_pjsua.Acc_Info[] py_pjsua.acc_enum_info (int count) "
+    "Enum accounts info.";
+static char pjsua_acc_find_for_outgoing_doc[] =
+    "int py_pjsua.acc_find_for_outgoing (string url) "
+    "This is an internal function to find the most appropriate account "
+    "to used to reach to the specified URL.";
+static char pjsua_acc_find_for_incoming_doc[] =
+    "int py_pjsua.acc_find_for_incoming (pjsip_rx_data_Object rdata) "
+    "This is an internal function to find the most appropriate account "
+    "to be used to handle incoming calls.";
+static char pjsua_acc_create_uac_contact_doc[] =
+    "string py_pjsua.acc_create_uac_contact (pj_pool_Object pool, "
+    "int acc_id, string uri) "
+    "Create a suitable URI to be put as Contact based on the specified "
+    "target URI for the specified account.";
+static char pjsua_acc_create_uas_contact_doc[] =
+    "string py_pjsua.acc_create_uas_contact (pj_pool_Object pool, "
+    "int acc_id, pjsip_rx_data_Object rdata) "
+    "Create a suitable URI to be put as Contact based on the information "
+    "in the incoming request.";
+
+/* END OF LIB ACCOUNT */
+
+/* LIB BUDDY */
+
+
+
+/*
+ * buddy_config_Object
+ * Buddy Config
  */
 typedef struct
@@ -4048,34 +4363,78 @@
     PyObject_HEAD
     /* Type-specific fields go here. */
-    int acc_id;
-} acc_id_Object;
-
-
-/*
- * acc_id_members
- * declares attributes accessible from 
- * both C and Python for acc_id object
- */
-static PyMemberDef acc_id_members[] =
-{
-    {
-        "acc_id", T_INT, offsetof(acc_id_Object, acc_id), 0,
-        "Account identification"
-    },
+    
+    PyObject * uri;
+    int subscribe;
+} buddy_config_Object;
+
+
+/*
+ * buddy_config_dealloc
+ * deletes a buddy_config from memory
+ */
+static void buddy_config_dealloc(buddy_config_Object* self)
+{
+    Py_XDECREF(self->uri);     
+    self->ob_type->tp_free((PyObject*)self);
+}
+
+
+/*
+ * buddy_config_new
+ * constructor for buddy_config object
+ */
+static PyObject * buddy_config_new(PyTypeObject *type, PyObject *args,
+                                    PyObject *kwds)
+{
+    buddy_config_Object *self;
+
+    self = (buddy_config_Object *)type->tp_alloc(type, 0);
+    if (self != NULL)
+    {
+        self->uri = PyString_FromString("");
+        if (self->uri == NULL)
+    	{
+            Py_DECREF(self);
+            return NULL;
+        }        
+    }
+    return (PyObject *)self;
+}
+
+/*
+ * buddy_config_members
+ */
+static PyMemberDef buddy_config_members[] =
+{
+    
+    {
+        "uri", T_OBJECT_EX,
+        offsetof(buddy_config_Object, uri), 0,
+        "TBuddy URL or name address."        
+    },
+    
+    {
+        "subscribe", T_INT, 
+        offsetof(buddy_config_Object, subscribe), 0,
+        "Specify whether presence subscription should start immediately. "
+    },
+    
     {NULL}  /* Sentinel */
 };
 
 
-/*
- * acc_id_Type
- */
-static PyTypeObject acc_id_Type =
+
+
+/*
+ * buddy_config_Type
+ */
+static PyTypeObject buddy_config_Type =
 {
     PyObject_HEAD_INIT(NULL)
     0,                              /*ob_size*/
-    "py_pjsua.Acc_ID",        /*tp_name*/
-    sizeof(acc_id_Object),    /*tp_basicsize*/
+    "py_pjsua.Buddy_Config",      /*tp_name*/
+    sizeof(buddy_config_Object),  /*tp_basicsize*/
     0,                              /*tp_itemsize*/
-    0,                              /*tp_dealloc*/
+    (destructor)buddy_config_dealloc,/*tp_dealloc*/
     0,                              /*tp_print*/
     0,                              /*tp_getattr*/
